import java.util.function.Consumer;
import java.util.function.Predicate;

class Salesperson
{
   private String name;
   private int salary;
   private int numsales;

   Salesperson(String name, int salary, int numsales)
   {
      this.name = name;
      this.salary = salary;
      this.numsales = numsales;
   }

   void addBonus(int amount)
   {
      salary += amount;
   }

   int getNumSales()
   {
      return numsales;
   }

   @Override
   public String toString()
   {
      return "name: " + name + ", salary: " + salary + ", numsales: " + 
             numsales;
   }
}

public class PCDemo 
{
   public static void main(String[] args)
   {
      Salesperson[] salespersons =
      {
         new Salesperson("John Doe", 40000, 549),
         new Salesperson("Jane Doe", 39000, 1500)
      };
 
      for (Salesperson salesperson: salespersons)
      {
         applyBonus(salesperson, 
                    salesperson_ -> salesperson_.getNumSales() > 1000,
                    salesperson_ -> salesperson_.addBonus(2500));
         System.out.println(salesperson);
      }
   }

   public static void applyBonus(Salesperson salesperson, 
                                 Predicate<Salesperson> predicate,
                                 Consumer<Salesperson> consumer)
   {
      // Use predicate to determine whether or not to add bonus.
      // Use consumer to add the bonus
      if (predicate.test(salesperson))
         consumer.accept(salesperson);
   }
}